osgUtil::PositionalStateContainer Class Reference

`#include <PositionalStateContainer>`

Inheritance diagram for osgUtil::PositionalStateContainer:

## Public Types

typedef std::pair< osg::ref_ptr< const osg::StateAttribute >, osg::ref_ptr< osg::RefMatrix > > | AttrMatrixPair
typedef std::vector< AttrMatrixPair > | AttrMatrixList
typedef std::map< unsigned int, AttrMatrixList > | TexUnitAttrMatrixListMap
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| PositionalStateContainer ()
virtual osg::Object * | cloneType () const
virtual osg::Object * | clone (const osg::CopyOp &) const
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual void | reset ()
AttrMatrixList & | getAttrMatrixList ()
virtual void | addPositionedAttribute (osg::RefMatrix *matrix, const osg::StateAttribute *attr)
TexUnitAttrMatrixListMap & | getTexUnitAttrMatrixListMap ()
virtual void | addPositionedTextureAttribute (unsigned int textureUnit, osg::RefMatrix *matrix, const osg::StateAttribute *attr)
virtual void | draw (osg::State &state, RenderLeaf *&previous, const osg::Matrix *postMultMatrix=0)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Public Attributes

AttrMatrixList | _attrList
TexUnitAttrMatrixListMap | _texAttrListMap

## Protected Member Functions

virtual | ~PositionalStateContainer ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

PositionalStateContainer base class. Used in RenderStage class.

## Member Typedef Documentation

## AttrMatrixList

typedef std::vector< AttrMatrixPair > osgUtil::PositionalStateContainer::AttrMatrixList

## AttrMatrixPair

typedef std::pair< osg::ref_ptr<const osg::StateAttribute> , osg::ref_ptr<osg::RefMatrix> > osgUtil::PositionalStateContainer::AttrMatrixPair

## TexUnitAttrMatrixListMap

typedef std::map< unsigned int, AttrMatrixList > osgUtil::PositionalStateContainer::TexUnitAttrMatrixListMap

## Constructor & Destructor Documentation

## PositionalStateContainer()

osgUtil::PositionalStateContainer::PositionalStateContainer | ( |  | ) |

Referenced by clone(), cloneType(), and isSameKindAs().

## ~PositionalStateContainer()

virtual osgUtil::PositionalStateContainer::~PositionalStateContainer | ( |  | ) |

protected virtual

## Member Function Documentation

## addPositionedAttribute()

virtual void osgUtil::PositionalStateContainer::addPositionedAttribute | ( | osg::RefMatrix * | matrix,
|  | const osg::StateAttribute * | attr )

inline virtual

References _attrList.

## addPositionedTextureAttribute()

virtual void osgUtil::PositionalStateContainer::addPositionedTextureAttribute | ( | unsigned int | textureUnit,
|  | osg::RefMatrix * | matrix,
|  | const osg::StateAttribute * | attr )

inline virtual

References _texAttrListMap.

## className()

virtual const char * osgUtil::PositionalStateContainer::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Implements osg::Object.

## clone()

virtual osg::Object * osgUtil::PositionalStateContainer::clone | ( | const osg::CopyOp & |  | ) | const

inline virtual

Clone an object, with Object* return type. Must be defined by derived classes.

Implements osg::Object.

References PositionalStateContainer().

## cloneType()

virtual osg::Object * osgUtil::PositionalStateContainer::cloneType | ( |  | ) | const

inline virtual

Clone the type of an object, with Object* return type. Must be defined by derived classes.

Implements osg::Object.

References PositionalStateContainer().

## draw()

virtual void osgUtil::PositionalStateContainer::draw | ( | osg::State & | state,
|  | RenderLeaf *& | previous,
|  | const osg::Matrix * | postMultMatrix = 0 )

virtual

## getAttrMatrixList()

AttrMatrixList & osgUtil::PositionalStateContainer::getAttrMatrixList | ( |  | ) |

inline

References _attrList.

## getTexUnitAttrMatrixListMap()

TexUnitAttrMatrixListMap & osgUtil::PositionalStateContainer::getTexUnitAttrMatrixListMap | ( |  | ) |

inline

References _texAttrListMap.

## isSameKindAs()

virtual bool osgUtil::PositionalStateContainer::isSameKindAs | ( | const osg::Object * | obj | ) | const

inline virtual

Reimplemented from osg::Object.

References PositionalStateContainer().

## libraryName()

virtual const char * osgUtil::PositionalStateContainer::libraryName | ( |  | ) | const

inline virtual

return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name.

Implements osg::Object.

## reset()

virtual void osgUtil::PositionalStateContainer::reset | ( |  | ) |

virtual

## Member Data Documentation

## _attrList

AttrMatrixList osgUtil::PositionalStateContainer::_attrList

Referenced by addPositionedAttribute(), and getAttrMatrixList().

## _texAttrListMap

TexUnitAttrMatrixListMap osgUtil::PositionalStateContainer::_texAttrListMap

Referenced by addPositionedTextureAttribute(), and getTexUnitAttrMatrixListMap().

The documentation for this class was generated from the following file:

- PositionalStateContainer